class ArticlesController < ApplicationController
  javascripts 'jquery.min','jquery.plugins','jquery.livequery','facebox','jquery.tablesorter','jquery.jeditable','application'

  # GET /articles
  # GET /articles.xml
  def index
    @articles = Article.find(:all,:order => 'id DESC')

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @articles }
      format.js   { render :partial => 'table'}
    end
  end

  # GET /articles/1
  # GET /articles/1.xml
  def show
    @article = Article.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @article }
      format.js   { render :html => 'show.html.erb' }
    end
  end

  # GET /articles/new
  # GET /articles/new.xml
  def new
    @article = Article.new

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @article }
      format.js
    end
  end

  # GET /articles/1/edit
  def edit
    @article = Article.find(params[:id])
  end

  # POST /articles
  # POST /articles.xml
  def create
    @article = Article.new(params[:article])

    respond_to do |format|
      if @article.save
        flash[:notice] = 'Article was successfully created.'
        format.html { redirect_to(@article) }
        format.xml  { render :xml => @article, :status => :created, :location => @article }
        format.js   { render :text => flash[:notice], :status => :ok}
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @article.errors, :status => :unprocessable_entity }
        format.js   { render :json => @article.errors, :status => :unprocessable_entity}
      end
    end
  end

  # PUT /articles/1
  # PUT /articles/1.xml
  def update
    @article = Article.find(params[:id])

    respond_to do |format|
      if @article.update_attributes(params[:article])
        flash[:notice] = 'Article was successfully updated.'
        format.html { redirect_to(@article) }
        format.xml  { head :ok }
        format.js   do
          #handle 2 response, normal update or edit_in_place update 
          if params[:edit_in_place]
            render :text => params[:article][params[:field]], :status => :ok
          else
            render :text => flash[:notice], :status => :ok
          end
        end
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @article.errors, :status => :unprocessable_entity }
        format.js   { render :json => @article.errors, :status => :unprocessable_entity}
      end
    end
  end

  # DELETE /articles/1
  # DELETE /articles/1.xml
  def destroy
    @article = Article.find(params[:id])
    @article.destroy

    respond_to do |format|
      flash[:notice] = 'Article was successfully deleted.'
      format.html { redirect_to(articles_url) }
      format.xml  { head :ok }
      format.js   { render :text => flash[:notice], :status => :ok}
    end
  end
end
