$.tablesorter.addWidget({
	id: "hightlight",
	format: function(table) {
		if(table.config.debug) { var time = new Date(); }
		$("tr:visible",table.tBodies[0])
		.hover(
			function(){$(this).addClass("highlight");},
	    function(){$(this).removeClass("highlight");}
	  );
		if(table.config.debug) { $.tablesorter.benchmark("Applying Zebra widget", time); }
	}
});

//// spinner on/off
// $('element').spinOn()
$.fn.spinOn = function(append) {
  if (append)
    $(this).append('<img src="/images/spinner.gif" class="spinner" />')
  else
    $(this).after('<img src="/images/spinner.gif"  class="spinner" />')
}
// $('element').spinOff()
$.fn.spinOff = function() {
    $('.spinner').hide();
}

//messages
$.errorBox = function(text) {
  $.facebox('<h2 class="title icon_warning">Whoops</h2>' + text)
}

$.successBox = function(text) {
  $.facebox('<h2 class="title icon_check">Success</h2>' + text)
}

//display error messages, taken from format.js { render :json => errors }
$.displayErrorMsg = function(data){
	$('.error_msg').remove();
	errors = eval(data);
	for (i in errors)
	{
		//alert(errors[i][0]);
		//alert(errors[i][1]);
		$('label[for*=_'+errors[i][0]+']').append(' <span style="color:red;display:none;" class="error_msg">....'+errors[i][1]+'</span>');
	}
	$('.error_msg').fadeIn();
}
////
// Callback receives responseText and 'success' / 'error'
// based on response.
//
// settings hash:
//   facebox: true        // a facebox 'loading' will open pre-submit
//   confirmation: string // a confirm pop-up will open with the supplied string
//
$.fn.spamjax = function(callback, settings) {
  var settings = settings || {}
  var options  = {}

  options.complete = function(xhr, ok) { callback.call(this, xhr.responseText, ok) }
	
  if (settings.confirmation) {
    options.beforeSubmit = function() {
      var execute = confirm(settings.confirmation)
      if (!execute) return false
      if (settings.facebox) $.facebox.loading()
    }
  } else if (settings.facebox) { 
    options.beforeSubmit = $.facebox.loading
  }

  // TODO: test this, yo
  $(this).ajaxForm($.extend(settings, options))
  return this
}

//return model[field] from a string as model_field
$.classToParam = function(cssclass) {
  record = cssclass.split('_');
  return record[0]+'['+record[1]+']';
}

//return field from a string as model_field
$.classToField = function(cssclass) {
  record = cssclass.split('_');
  return record[1];
}

$(document).ready(function($) {
  
	//edit in place text fields
	$(".edit").livequery(function() {
		$(this).editable($(this).attr('rel'), {
        name: $.classToParam($(this).attr('id')),
        submitdata: { _method: "put",edit_in_place: 1 , field: $.classToField($(this).attr('id'))},
        indicator : "Saving...",
        tooltip   : 'Click to edit...'
    });
	}),
	
	//edit in place text area
	$(".edit_area").livequery(function() {	
		$(this).editable($(this).attr('rel'), {
      name: $.classToParam($(this).attr('id')),
      submitdata: { _method: "put",edit_in_place: 1 , field: $.classToField($(this).attr('id'))},
      type: 'textarea',
      cancel    : 'Cancel',
      submit    : 'OK',
      indicator : '<img src="/images/spinner.gif" class="spinner" />',
      tooltip   : 'Click to edit...'
    });
	}),



  // delete action
	$('.delete_button').livequery(function() { 
	$(this).spamjax(function(data, status) {
    if (status == 'success') {
      $.successBox(data)
      var id = $(this).attr('url').split('/').pop()
      $('#record_' + id).hide();
			return false;
    } else {
      $.errorBox(data)
    }
  }, { facebox: true, confirmation: "Are you sure?" })
  });  
	
	// create action
	$('.new_article').livequery(function() {
		$('#article_submit').click(
				function(){
					$(this).spinOn();
				})
	$(this).spamjax(function(data, status) {
    if (status == 'success') {
			//update index list
			$('#articles').load('/',{_method: 'GET'}, function(){                    
				//success
				$('tr:nth-child(1) > td').highlightFade({color:'#5494cf',speed:2000,iterator:'exponential'});
  		});
			$.successBox(data); 
			return false;
    } else {
			$.displayErrorMsg(data)
    }
		$('#article_submit').spinOff();
  }),{}
  });
	
	// update action
	$('.edit_article').livequery(function() {
		$('#article_submit').click(
				function(){
					$(this).spinOn();
		})
		var id = $(this).attr('action').split('/').pop(); 
	$(this).spamjax(function(data, status) {
    if (status == 'success') {
			//update index list
			$('#articles').load('/',{_method: 'GET'}, function(){
				//success                    
				$('#record_' + id + ' > td').highlightFade({color:'#5494cf',speed:2000,iterator:'exponential'});
  		});
			$.successBox(data); 
			return false;
    } else {
			$.displayErrorMsg(data)
    }
		$('#article_submit').spinOff();
  }),{}
  });
	
	//various behaviour
	$('.show_button').livequery(function() { 
		$(this).facebox();
	});
	
	$('.edit_button').livequery(function() { 
		$(this).facebox();
	});

	
	$('a[rel*=facebox]').facebox();
	
	//table sorter
	$('.tablesorter').livequery(
		function() { 
			$('.tablesorter').tablesorter({widgets: ['zebra','hightlight']})
		}
	);
	
	
}); 

$.ajaxSetup({ 
	'beforeSend': function(xhr) {xhr.setRequestHeader("Accept","text/javascript")} 
});

$(document).ajaxSend(function(event, request, settings) {
  if (typeof(AUTH_TOKEN) == "undefined") return;
  settings.data = settings.data || "";
  settings.data += (settings.data ? "&" : "") + "authenticity_token=" + encodeURIComponent(AUTH_TOKEN);
});

