class Array
  def merge(other_array)
    push(other_array).flatten!.uniq!
  end
end

module UnobtrusiveJavascriptInclusion
  module ActionControllerExtension
    def self.included(base)
      base.extend ClassMethods
    end
    
    module ClassMethods
      def javascripts(*scripts)
        options = scripts.extract_options!
        
        before_filter(options) do |controller|
          controller.instance_eval do
            @additional_javascripts ||= []
            @additional_javascripts.merge(scripts)
          end
        end
      end
    end
  end
  
  module ActionViewExtension
    def include_unobtrusive_javascripts
      return unless @additional_javascripts
      javascript_include_tag *@additional_javascripts
    end
  end
end